local galaxyNumbers = {
	["0"] = "GALAXYNUM0",
	["1"] = "GALAXYNUM1",
	["2"] = "GALAXYNUM2",
	["3"] = "GALAXYNUM3",
	["4"] = "GALAXYNUM4",
	["5"] = "GALAXYNUM5",
	["6"] = "GALAXYNUM6",
	["7"] = "GALAXYNUM7",
	["8"] = "GALAXYNUM8",
	["9"] = "GALAXYNUM9",
}

hud.add(function(v,player)
	local time = player.nightstime/TICRATE
	
	local seconds = time % 60
	if seconds < 10 then
		seconds = "0"..$
	end
	-- draw seconds instead of (time % 60)
	
	local purplerings = 0
	
	if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.capsule and player.capsule.valid then
		purplerings = AngleFixed(player.capsule.angle)/FRACUNIT
	else
		purplerings = mapheaderinfo[gamemap].ssspheres
	end
	
	if purplecoin == true and gamestate == GS_LEVEL and G_IsSpecialStage(gamemap) == true then
		if not (player.mo.skin == "orbit" and player.orbithud) --orbit will have a timer of his own
			v.drawString(155,185,(time / 60),V_SNAPTOBOTTOM|V_YELLOWMAP,"center") --mins
			v.drawString(160,185,":",V_SNAPTOBOTTOM|V_YELLOWMAP,"center") --:
			v.drawString(170,185,seconds,V_SNAPTOBOTTOM|V_YELLOWMAP,"center") --secs
			v.drawScaled(140*FRACUNIT,183*FRACUNIT,FRACUNIT/3,v.cachePatch("CLOCKICON"),V_SNAPTOBOTTOM) --clock icon
			v.drawScaled(20*FRACUNIT,178*FRACUNIT,FRACUNIT/2,v.cachePatch("PURPC0"),V_FLIP|V_SNAPTOBOTTOM|V_SNAPTOLEFT) --purple ring icon
		end
		local num = 0
		for p in players.iterate do
			num = $ + p.spheres
		end
		local numstring = tostring(num)
		local numlength = max(numstring:len(),min(tostring(purplerings):len(),3))
		local sc = player.spherectime or 0
		local ex = max(numlength-3,-3)*10
		local y = 163
		if sc==4 y=$-2 elseif sc >= 2 y=$+1 elseif sc>=1 y=$+2 end --collect animation
		for i=1, numlength
			local currentnum = galaxyNumbers["0"]
			local nl = numstring:len()
			if i <= nl
				currentnum = galaxyNumbers[string.sub(numstring, nl+1-i, nl+1-i)] or galaxyNumbers["0"]
			end
			v.drawScaled((65 - (i*13) + ex)*FU, y*FRACUNIT, FRACUNIT/2,
				v.cachePatch(currentnum), V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(nil,nil,(sc>=2 and "PurpleRings_Bright" or nil)))
		end
		--v.drawString(20,170,player.spheres,0,"center")
		if not player.bonustime
			v.drawString(70+ex,170,"/",V_SNAPTOBOTTOM|V_SNAPTOLEFT,"center")
			v.drawString(85+ex,170,purplerings,V_SNAPTOBOTTOM|V_SNAPTOLEFT,"center")
		end
	end
end, "game")